Hammer Development Docs
=======================

Hammer is a generic clamp-based CLI framework. It uses existing clamp features and adds some extra utilities.
We recommend to get familiar with the [Clamp documentation](https://github.com/mdub/clamp/#quick-start)
before creating hammer specific plugins.

Contents:
 - [Writing a plugin](writing_a_plugin.md#writing-your-own-hammer-plugin)
 - [Creating commands](creating_commands.md#create-your-first-command)
 - [Output adapters, formatters, etc](output.md#output)
 - [Help modification](help_modification.md#modify-an-existing-help)
 - [Commands modification](commands_modification.md#modify-an-existing-command)
 - [Command extensions](commands_extension.md#extend-an-existing-command)
 - [Option builders](option_builders.md#option-builders)
 - [Creating ApiPie commands](creating_apipie_commands.md#creating-commands-for-restful-api-with-apipie)
 - [Development tips](development_tips.md#development-tips)
 - [Option normalizers](option_normalizers.md#option-normalizers)
 - [Internationalization](i18n.md#internationalization)
 - [PR review checklist](review_checklist.md)

Links:
 - slides from tutorial at Config Management Camp 2015: [Hacking with hammer](https://tstrachota.fedorapeople.org/slides/hacking_with_hammer/)
